Index: LMDZ6/trunk/libf/phylmd/ecrad/radiation_aerosol_optics.F90
===================================================================
--- LMDZ6/trunk/libf/phylmd/ecrad/radiation_aerosol_optics.F90	(revision 4488)
+++ LMDZ6/trunk/libf/phylmd/ecrad/radiation_aerosol_optics.F90	(revision 4489)
@@ -63,9 +82,699 @@
     end if
 
-    call config%aerosol_optics%print_description(config%i_aerosol_type_map(1:config%n_aerosol_types))
+    if (config%iverbosesetup >= 1) then
+      call config%aerosol_optics%print_description(config%i_aerosol_type_map(1:config%n_aerosol_types))
+    end if
 
     if (lhook) call dr_hook('radiation_aerosol_optics:setup_aerosol_optics',1,hook_handle)
 
   end subroutine setup_aerosol_optics
+
+
+  !---------------------------------------------------------------------
+  ! Read file containing high spectral resolution optical properties
+  ! and average to the spectral intervals of the current gas-optics
+  ! scheme
+  subroutine setup_general_aerosol_optics(config)
+
+    use parkind1,                      only : jprb
+    use yomhook,                       only : lhook, dr_hook
+    use easy_netcdf,                   only : netcdf_file
+    use radiation_config,              only : config_type
+    use radiation_aerosol_optics_data, only : aerosol_optics_type
+    use radiation_spectral_definition, only : SolarReferenceTemperature, &
+         &                                    TerrestrialReferenceTemperature
+    use radiation_io,                  only : nulout
+
+    type(config_type), intent(inout), target :: config
+
+    ! The NetCDF file containing the aerosol optics data
+    type(netcdf_file)  :: file
+
+    ! Wavenumber points in NetCDF file
+    real(jprb), allocatable :: wavenumber(:) ! cm-1
+
+    ! Hydrophilic aerosol properties
+    real(jprb), allocatable :: mass_ext_philic(:,:,:)    ! Mass-ext coefficient (m2 kg-1)
+    real(jprb), allocatable :: ssa_philic(:,:,:)         ! Single-scattering albedo
+    real(jprb), allocatable :: g_philic(:,:,:)           ! Asymmetry factor
+    real(jprb), allocatable :: lidar_ratio_philic(:,:,:) ! Lidar ratio (sr)
+
+    ! Hydrophobic aerosol properties
+    real(jprb), allocatable :: mass_ext_phobic(:,:)      ! Mass-ext coefficient (m2 kg-1)
+    real(jprb), allocatable :: ssa_phobic(:,:)           ! Single-scattering albedo
+    real(jprb), allocatable :: g_phobic(:,:)             ! Asymmetry factor
+    real(jprb), allocatable :: lidar_ratio_phobic(:,:)   ! Lidar ratio (sr)
+
+    ! Mapping matrix between optical properties at the wavenumbers in
+    ! the file, and spectral intervals used by the gas-optics scheme
+    real(jprb), allocatable :: mapping(:,:)
+
+    ! Pointer to the aerosol optics coefficients for brevity of access
+    type(aerosol_optics_type), pointer :: ao
+
+    ! Target monochromatic wavenumber for interpolation (cm-1)
+    real(jprb) :: wavenumber_target
+
+    ! Number of spectral points describing aerosol properties in the
+    ! shortwave and longwave
+    integer    :: nspecsw, nspeclw
+
+    ! Number of monochromatic wavelengths required
+    integer    :: nmono
+
+    integer    :: n_type_philic, n_type_phobic, nrh, nwn
+    integer    :: jtype, jwl, iwn
+
+    ! Weight of first point in interpolation
+    real(jprb) :: weight1
+
+    real(jprb) :: hook_handle
+
+    if (lhook) call dr_hook('radiation_aerosol_optics:setup_general_aerosol_optics',0,hook_handle)
+
+    ao => config%aerosol_optics
+
+    call file%open(trim(config%aerosol_optics_file_name), iverbose=config%iverbosesetup)
+
+    if (.not. file%exists('wavenumber')) then
+      ! Assume we have an old-style aerosol optics file with optical
+      ! properties provided per pre-defined band
+      call file%close()
+      if (config%iverbosesetup >= 2) then
+        write(nulout,'(a)') 'Legacy aerosol optics file: mapping between bands'
+      end if
+      call setup_general_aerosol_optics_legacy(config, trim(config%aerosol_optics_file_name))
+      return
+    end if
+
+    if (file%exists('mass_ext_hydrophilic')) then
+      ao%use_hydrophilic = .true.
+    else
+      ao%use_hydrophilic = .false.
+    end if
+ 
+    call file%get('wavenumber', wavenumber)
+    nwn = size(wavenumber)
+
+    ! Read the raw scattering data
+    call file%get('mass_ext_hydrophobic',    mass_ext_phobic)
+    call file%get('ssa_hydrophobic',         ssa_phobic)
+    call file%get('asymmetry_hydrophobic',   g_phobic)
+    call file%get('lidar_ratio_hydrophobic', lidar_ratio_phobic)
+
+    call file%get_global_attribute('description_hydrophobic', &
+         &                         ao%description_phobic_str)
+
+    if (ao%use_hydrophilic) then
+      call file%get('mass_ext_hydrophilic',    mass_ext_philic)
+      call file%get('ssa_hydrophilic',         ssa_philic)
+      call file%get('asymmetry_hydrophilic',   g_philic)
+      call file%get('lidar_ratio_hydrophilic', lidar_ratio_philic)
+
+      call file%get('relative_humidity1',      ao%rh_lower)
+
+      call file%get_global_attribute('description_hydrophilic', &
+           &                         ao%description_philic_str)
+    end if
+
+    ! Close aerosol scattering file
+    call file%close()
+
+    n_type_phobic = size(mass_ext_phobic, 2)
+    if (ao%use_hydrophilic) then
+      n_type_philic = size(mass_ext_philic, 3)
+      nrh = size(ao%rh_lower)
+    else
+      n_type_philic = 0
+      nrh = 0
+    end if
+
+    if (config%do_cloud_aerosol_per_sw_g_point) then
+      nspecsw = config%gas_optics_sw%spectral_def%ng
+    else
+      nspecsw = config%gas_optics_sw%spectral_def%nband
+    end if
+
+    if (config%do_cloud_aerosol_per_lw_g_point) then
+      nspeclw = config%gas_optics_lw%spectral_def%ng
+    else
+      nspeclw = config%gas_optics_lw%spectral_def%nband
+    end if
+
+    if (allocated(ao%wavelength_mono)) then
+      ! Monochromatic wavelengths also required
+      nmono = size(ao%wavelength_mono)
+    else
+      nmono = 0
+    end if
+
+    call ao%allocate(n_type_phobic, n_type_philic, nrh, nspeclw, nspecsw, nmono)
+
+    if (config%do_sw) then
+      call config%gas_optics_sw%spectral_def%calc_mapping(SolarReferenceTemperature, &
+           &  wavenumber, mapping, use_bands=(.not. config%do_cloud_aerosol_per_sw_g_point))
+
+      ao%mass_ext_sw_phobic = matmul(mapping, mass_ext_phobic)
+      ao%ssa_sw_phobic = matmul(mapping, mass_ext_phobic*ssa_phobic) &
+           &           / ao%mass_ext_sw_phobic
+      ao%g_sw_phobic = matmul(mapping, mass_ext_phobic*ssa_phobic*g_phobic) &
+           &         / (ao%mass_ext_sw_phobic*ao%ssa_sw_phobic)
+
+      if (ao%use_hydrophilic) then
+        do jtype = 1,n_type_philic
+          ao%mass_ext_sw_philic(:,:,jtype) = matmul(mapping, mass_ext_philic(:,:,jtype))
+          ao%ssa_sw_philic(:,:,jtype) = matmul(mapping, mass_ext_philic(:,:,jtype) &
+               &                                        *ssa_philic(:,:,jtype)) &
+               &           / ao%mass_ext_sw_philic(:,:,jtype)
+          ao%g_sw_philic(:,:,jtype) = matmul(mapping, mass_ext_philic(:,:,jtype) &
+               &                       *ssa_philic(:,:,jtype)*g_philic(:,:,jtype)) &
+               &         / (ao%mass_ext_sw_philic(:,:,jtype)*ao%ssa_sw_philic(:,:,jtype))
+        end do
+      end if
+    end if
+
+    if (config%do_lw) then
+      call config%gas_optics_lw%spectral_def%calc_mapping(TerrestrialReferenceTemperature, &
+           &  wavenumber, mapping, use_bands=(.not. config%do_cloud_aerosol_per_lw_g_point))
+
+      ao%mass_ext_lw_phobic = matmul(mapping, mass_ext_phobic)
+      ao%ssa_lw_phobic = matmul(mapping, mass_ext_phobic*ssa_phobic) &
+           &           / ao%mass_ext_lw_phobic
+      ao%g_lw_phobic = matmul(mapping, mass_ext_phobic*ssa_phobic*g_phobic) &
+           &         / (ao%mass_ext_lw_phobic*ao%ssa_lw_phobic)
+
+      if (ao%use_hydrophilic) then
+        do jtype = 1,n_type_philic
+          ao%mass_ext_lw_philic(:,:,jtype) = matmul(mapping, mass_ext_philic(:,:,jtype))
+          ao%ssa_lw_philic(:,:,jtype) = matmul(mapping, mass_ext_philic(:,:,jtype) &
+               &                                        *ssa_philic(:,:,jtype)) &
+               &           / ao%mass_ext_lw_philic(:,:,jtype)
+          ao%g_lw_philic(:,:,jtype) = matmul(mapping, mass_ext_philic(:,:,jtype) &
+               &                       *ssa_philic(:,:,jtype)*g_philic(:,:,jtype)) &
+               &         / (ao%mass_ext_lw_philic(:,:,jtype)*ao%ssa_lw_philic(:,:,jtype))
+        end do
+      end if
+    end if
+
+    if (allocated(ao%wavelength_mono)) then
+      ! Monochromatic wavelengths also required
+      do jwl = 1,nmono
+        ! Wavelength (m) to wavenumber (cm-1)
+        wavenumber_target = 0.01_jprb / ao%wavelength_mono(jwl)
+        ! Find index to first interpolation point, and its weight
+        if (wavenumber_target <= wavenumber(1)) then
+          weight1 = 1.0_jprb
+          iwn = 1
+        else if (wavenumber_target >= wavenumber(nwn)) then
+          iwn = nwn-1
+          weight1 = 0.0_jprb
+        else
+          iwn = 1
+          do while (wavenumber(iwn+1) < wavenumber_target .and. iwn < nwn-1)
+            iwn = iwn + 1
+          end do
+          weight1 = (wavenumber(iwn+1)-wavenumber_target) &
+               &  / (wavenumber(iwn+1)-wavenumber(iwn))
+        end if
+        ! Linear interpolation
+        ao%mass_ext_mono_phobic(jwl,:) = weight1 * mass_ext_phobic(iwn,:) &
+             &             + (1.0_jprb - weight1)* mass_ext_phobic(iwn+1,:)
+        ao%ssa_mono_phobic(jwl,:)      = weight1 * ssa_phobic(iwn,:) &
+             &             + (1.0_jprb - weight1)* ssa_phobic(iwn+1,:)
+        ao%g_mono_phobic(jwl,:)        = weight1 * g_phobic(iwn,:) &
+             &             + (1.0_jprb - weight1)* g_phobic(iwn+1,:)
+        ao%lidar_ratio_mono_phobic(jwl,:) = weight1 * lidar_ratio_phobic(iwn,:) &
+             &                + (1.0_jprb - weight1)* lidar_ratio_phobic(iwn+1,:)
+        if (ao%use_hydrophilic) then
+          ao%mass_ext_mono_philic(jwl,:,:) = weight1 * mass_ext_philic(iwn,:,:) &
+               &               + (1.0_jprb - weight1)* mass_ext_philic(iwn+1,:,:)
+          ao%ssa_mono_philic(jwl,:,:)      = weight1 * ssa_philic(iwn,:,:) &
+               &               + (1.0_jprb - weight1)* ssa_philic(iwn+1,:,:)
+          ao%g_mono_philic(jwl,:,:)        = weight1 * g_philic(iwn,:,:) &
+               &               + (1.0_jprb - weight1)* g_philic(iwn+1,:,:)
+          ao%lidar_ratio_mono_philic(jwl,:,:) = weight1 * lidar_ratio_philic(iwn,:,:) &
+               &                  + (1.0_jprb - weight1)* lidar_ratio_philic(iwn+1,:,:)
+        end if
+      end do
+    end if
+
+    ! Deallocate memory local to this routine
+    deallocate(mass_ext_phobic)
+    deallocate(ssa_phobic)
+    deallocate(g_phobic)
+    deallocate(lidar_ratio_phobic)
+    if (ao%use_hydrophilic) then
+      deallocate(mass_ext_philic)
+      deallocate(ssa_philic)
+      deallocate(g_philic)
+      deallocate(lidar_ratio_philic)
+    end if
+
+    if (lhook) call dr_hook('radiation_aerosol_optics:setup_general_aerosol_optics',1,hook_handle)
+
+  end subroutine setup_general_aerosol_optics
+
+    !---------------------------------------------------------------------
+  ! Read LMDZ file containing high spectral resolution optical properties
+  ! and average to the spectral intervals of the current gas-optics
+  ! scheme
+  subroutine setup_general_aerosol_optics_lmdz(config,file_name)
+
+    use parkind1,                      only : jprb
+    use yomhook,                       only : lhook, dr_hook
+!    use easy_netcdf,                   only : netcdf_file
+    use radiation_config,              only : config_type
+    use radiation_aerosol_optics_data, only : aerosol_optics_type
+    use radiation_spectral_definition, only : SolarReferenceTemperature, &
+         &                                    TerrestrialReferenceTemperature
+    use radiation_io,                  only : nulout
+    use netcdf95, only: nf95_open, nf95_inq_grp_full_ncid, nf95_close, &
+         nf95_inq_dimid, nf95_inq_varid, nf95_inquire_dimension, &
+         nf95_get_var, nf95_gw_var
+    use netcdf, only: nf90_nowrite
+
+
+    type(config_type), intent(inout), target :: config
+
+!    ! The NetCDF file containing the aerosol optics data
+!    type(netcdf_file)  :: file
+
+    character(len=*), intent(in):: file_name
+    ! NetCDF file containing the aerosol optics data
+
+    ! Wavenumber points in NetCDF file
+    real(jprb), allocatable :: wavenumber(:) ! cm-1
+
+    ! Hydrophilic aerosol properties
+    real(jprb), allocatable :: mass_ext_philic(:,:,:)    ! Mass-ext coefficient (m2 kg-1)
+    real(jprb), allocatable :: ssa_philic(:,:,:)         ! Single-scattering albedo
+    real(jprb), allocatable :: g_philic(:,:,:)           ! Asymmetry factor
+    real(jprb), allocatable :: lidar_ratio_philic(:,:,:) ! Lidar ratio (sr)
+
+    ! Hydrophobic aerosol properties
+    real(jprb), allocatable :: mass_ext_phobic(:,:)      ! Mass-ext coefficient (m2 kg-1)
+    real(jprb), allocatable :: ssa_phobic(:,:)           ! Single-scattering albedo
+    real(jprb), allocatable :: g_phobic(:,:)             ! Asymmetry factor
+    real(jprb), allocatable :: lidar_ratio_phobic(:,:)   ! Lidar ratio (sr)
+
+    ! Mapping matrix between optical properties at the wavenumbers in
+    ! the file, and spectral intervals used by the gas-optics scheme
+    real(jprb), allocatable :: mapping(:,:)
+
+    ! Pointer to the aerosol optics coefficients for brevity of access
+    type(aerosol_optics_type), pointer :: ao
+
+    ! Target monochromatic wavenumber for interpolation (cm-1)
+    real(jprb) :: wavenumber_target
+
+    ! Number of spectral points describing aerosol properties in the
+    ! shortwave and longwave
+    integer    :: nspecsw, nspeclw
+
+    ! Number of monochromatic wavelengths required
+    integer    :: nmono
+
+    integer    :: n_type_philic, n_type_phobic, nrh, nwn
+    integer    :: jtype, jwl, iwn
+
+    ! Weight of first point in interpolation
+    real(jprb) :: weight1
+
+    real(jprb) :: hook_handle
+
+    ! Local:
+    integer ncid, grpid, dimid, varid
+
+    if (lhook) call dr_hook('radiation_aerosol_optics:setup_general_aerosol_optics',0,hook_handle)
+
+    ao => config%aerosol_optics
+
+    ao%use_hydrophilic = .true.
+    ao%use_monochromatic = .true.
+    print*,'file_name= ',file_name
+    call nf95_open(file_name, nf90_nowrite, ncid)
+    call nf95_inq_grp_full_ncid(ncid, "Hydrophilic", grpid)
+    call nf95_inq_dimid(grpid, "hur", dimid)
+    call nf95_inquire_dimension(grpid, dimid, nclen = ao%nrh)
+!    allocate(ao%rh_lower(ao%nrh))
+    call nf95_inq_varid(grpid, "hur_bounds", varid)
+    call nf95_get_var(grpid, varid, ao%rh_lower, count_nc = [1, ao%nrh])
+
+    ! Hydrophilic/LW_bands:
+    call nf95_inq_grp_full_ncid(ncid, "Hydrophilic/LW_bands", grpid)
+    call nf95_inq_varid(grpid, "asymmetry", varid)
+    call nf95_gw_var(grpid, varid, ao%g_lw_philic)
+    call nf95_inq_varid(grpid, "single_scat_alb", varid)
+    call nf95_gw_var(grpid, varid, ao%ssa_lw_philic)
+    call nf95_inq_varid(grpid, "mass_ext", varid)
+    call nf95_gw_var(grpid, varid, ao%mass_ext_lw_philic)
+
+    ! Hydrophilic/SW_bands:
+    call nf95_inq_grp_full_ncid(ncid, "Hydrophilic/SW_bands", grpid)
+    call nf95_inq_varid(grpid, "asymmetry", varid)
+    call nf95_gw_var(grpid, varid, ao%g_sw_philic)
+    ao%g_sw_philic = cshift(ao%g_sw_philic, 1)
+    call nf95_inq_varid(grpid, "single_scat_alb", varid)
+    call nf95_gw_var(grpid, varid, ao%ssa_sw_philic)
+    ao%g_sw_philic = cshift(ao%ssa_sw_philic, 1)
+    call nf95_inq_varid(grpid, "mass_ext", varid)
+    call nf95_gw_var(grpid, varid, ao%mass_ext_sw_philic)
+    ao%g_sw_philic = cshift(ao%mass_ext_sw_philic, 1)
+
+    ! Hydrophilic/Monochromatic:
+    call nf95_inq_grp_full_ncid(ncid, "Hydrophilic/Monochromatic", grpid)
+    call nf95_inq_varid(grpid, "mass_ext", varid)
+    call nf95_gw_var(grpid, varid, ao%mass_ext_mono_philic)
+
+    ! Hydrophobic/LW_bands:
+    call nf95_inq_grp_full_ncid(ncid, "Hydrophobic/LW_bands", grpid)
+    call nf95_inq_varid(grpid, "asymmetry", varid)
+    call nf95_gw_var(grpid, varid, ao%g_lw_phobic)
+    call nf95_inq_varid(grpid, "single_scat_alb", varid)
+    call nf95_gw_var(grpid, varid, ao%ssa_lw_phobic)
+    call nf95_inq_varid(grpid, "mass_ext", varid)
+    call nf95_gw_var(grpid, varid, ao%mass_ext_lw_phobic)
+
+    ! Hydrophobic/SW_bands:
+    call nf95_inq_grp_full_ncid(ncid, "Hydrophobic/SW_bands", grpid)
+    call nf95_inq_varid(grpid, "asymmetry", varid)
+    call nf95_gw_var(grpid, varid, ao%g_sw_phobic)
+    ao%g_sw_phobic = cshift(ao%g_sw_phobic, 1)
+    call nf95_inq_varid(grpid, "single_scat_alb", varid)
+    call nf95_gw_var(grpid, varid, ao%ssa_sw_phobic)
+    ao%g_sw_phobic = cshift(ao%ssa_sw_phobic, 1)
+    call nf95_inq_varid(grpid, "mass_ext", varid)
+    call nf95_gw_var(grpid, varid, ao%mass_ext_sw_phobic)
+    ao%g_sw_phobic = cshift(ao%mass_ext_sw_phobic, 1)
+! AI ATTENTION    
+    call nf95_inq_varid(grpid, "wavenumber", varid)
+    call nf95_gw_var(grpid, varid, wavenumber)
+
+    ! Hydrophobic/Monochromatic:
+    call nf95_inq_grp_full_ncid(ncid, "Hydrophobic/Monochromatic", grpid)
+    call nf95_inq_varid(grpid, "mass_ext", varid)
+    call nf95_gw_var(grpid, varid, ao%mass_ext_mono_phobic)
+
+!    call file%get('wavenumber', wavenumber)
+!    nwn = size(wavenumber)
+
+!    call file%get_global_attribute('description_hydrophobic', &
+!         &                         ao%description_phobic_str)
+
+
+!      call file%get('relative_humidity1',      ao%rh_lower)
+
+!      call file%get_global_attribute('description_hydrophilic', &
+!           &                         ao%description_philic_str)
+
+    ! Close aerosol scattering file
+!    call file%close()
+
+    call nf95_close(ncid)
+
+    ! Get array sizes
+!    ao%n_bands_lw = size(ao%mass_ext_lw_phobic, 1)
+!    ao%n_bands_sw = size(ao%mass_ext_sw_phobic, 1)
+!    ao%n_mono_wl = size(ao%mass_ext_mono_phobic, 1)
+!    ao%n_type_phobic = size(ao%mass_ext_lw_phobic, 2)
+!    ao%n_type_philic = size(ao%mass_ext_lw_philic, 3)
+
+    ! Allocate memory for mapping arrays
+!    ao%ntype = ao%n_type_phobic + ao%n_type_philic
+!    allocate(ao%iclass(ao%ntype))
+!    allocate(ao%itype(ao%ntype))
+
+!    ao%iclass = IAerosolClassUndefined
+!    ao%itype  = 0
+
+    n_type_phobic = size(mass_ext_phobic, 2)
+    if (ao%use_hydrophilic) then
+      n_type_philic = size(mass_ext_philic, 3)
+      nrh = size(ao%rh_lower)
+    else
+      n_type_philic = 0
+      nrh = 0
+    end if
+
+    if (config%do_cloud_aerosol_per_sw_g_point) then
+      nspecsw = config%gas_optics_sw%spectral_def%ng
+    else
+      nspecsw = config%gas_optics_sw%spectral_def%nband
+    end if
+
+    if (config%do_cloud_aerosol_per_lw_g_point) then
+      nspeclw = config%gas_optics_lw%spectral_def%ng
+    else
+      nspeclw = config%gas_optics_lw%spectral_def%nband
+    end if
+
+    if (allocated(ao%wavelength_mono)) then
+      ! Monochromatic wavelengths also required
+      nmono = size(ao%wavelength_mono)
+    else
+      nmono = 0
+    end if
+
+    call ao%allocate(n_type_phobic, n_type_philic, nrh, nspeclw, nspecsw, nmono)
+
+    if (config%do_sw) then
+      call config%gas_optics_sw%spectral_def%calc_mapping(SolarReferenceTemperature, &
+           &  wavenumber, mapping, use_bands=(.not. config%do_cloud_aerosol_per_sw_g_point))
+
+      ao%mass_ext_sw_phobic = matmul(mapping, mass_ext_phobic)
+      ao%ssa_sw_phobic = matmul(mapping, mass_ext_phobic*ssa_phobic) &
+           &           / ao%mass_ext_sw_phobic
+      ao%g_sw_phobic = matmul(mapping, mass_ext_phobic*ssa_phobic*g_phobic) &
+           &         / (ao%mass_ext_sw_phobic*ao%ssa_sw_phobic)
+
+      if (ao%use_hydrophilic) then
+        do jtype = 1,n_type_philic
+          ao%mass_ext_sw_philic(:,:,jtype) = matmul(mapping, mass_ext_philic(:,:,jtype))
+          ao%ssa_sw_philic(:,:,jtype) = matmul(mapping, mass_ext_philic(:,:,jtype) &
+               &                                        *ssa_philic(:,:,jtype)) &
+               &           / ao%mass_ext_sw_philic(:,:,jtype)
+          ao%g_sw_philic(:,:,jtype) = matmul(mapping, mass_ext_philic(:,:,jtype) &
+               &                       *ssa_philic(:,:,jtype)*g_philic(:,:,jtype)) &
+               &         / (ao%mass_ext_sw_philic(:,:,jtype)*ao%ssa_sw_philic(:,:,jtype))
+        end do
+      end if
+    end if
+    if (config%do_lw) then
+      call config%gas_optics_lw%spectral_def%calc_mapping(TerrestrialReferenceTemperature, &
+           &  wavenumber, mapping, use_bands=(.not. config%do_cloud_aerosol_per_lw_g_point))
+
+      ao%mass_ext_lw_phobic = matmul(mapping, mass_ext_phobic)
+      ao%ssa_lw_phobic = matmul(mapping, mass_ext_phobic*ssa_phobic) &
+           &           / ao%mass_ext_lw_phobic
+      ao%g_lw_phobic = matmul(mapping, mass_ext_phobic*ssa_phobic*g_phobic) &
+           &         / (ao%mass_ext_lw_phobic*ao%ssa_lw_phobic)
+
+      if (ao%use_hydrophilic) then
+        do jtype = 1,n_type_philic
+          ao%mass_ext_lw_philic(:,:,jtype) = matmul(mapping, mass_ext_philic(:,:,jtype))
+          ao%ssa_lw_philic(:,:,jtype) = matmul(mapping, mass_ext_philic(:,:,jtype) &
+               &                                        *ssa_philic(:,:,jtype)) &
+               &           / ao%mass_ext_lw_philic(:,:,jtype)
+          ao%g_lw_philic(:,:,jtype) = matmul(mapping, mass_ext_philic(:,:,jtype) &
+               &                       *ssa_philic(:,:,jtype)*g_philic(:,:,jtype)) &
+               &         / (ao%mass_ext_lw_philic(:,:,jtype)*ao%ssa_lw_philic(:,:,jtype))
+        end do
+      end if
+    end if
+
+    if (allocated(ao%wavelength_mono)) then
+      ! Monochromatic wavelengths also required
+      do jwl = 1,nmono
+        ! Wavelength (m) to wavenumber (cm-1)
+        wavenumber_target = 0.01_jprb / ao%wavelength_mono(jwl)
+        ! Find index to first interpolation point, and its weight
+        if (wavenumber_target <= wavenumber(1)) then
+          weight1 = 1.0_jprb
+          iwn = 1
+        else if (wavenumber_target >= wavenumber(nwn)) then
+          iwn = nwn-1
+          weight1 = 0.0_jprb
+        else
+          iwn = 1
+          do while (wavenumber(iwn+1) < wavenumber_target .and. iwn < nwn-1)
+            iwn = iwn + 1
+          end do
+          weight1 = (wavenumber(iwn+1)-wavenumber_target) &
+               &  / (wavenumber(iwn+1)-wavenumber(iwn))
+        end if
+        ! Linear interpolation
+        ao%mass_ext_mono_phobic(jwl,:) = weight1 * mass_ext_phobic(iwn,:) &
+             &             + (1.0_jprb - weight1)* mass_ext_phobic(iwn+1,:)
+        ao%ssa_mono_phobic(jwl,:)      = weight1 * ssa_phobic(iwn,:) &
+             &             + (1.0_jprb - weight1)* ssa_phobic(iwn+1,:)
+        ao%g_mono_phobic(jwl,:)        = weight1 * g_phobic(iwn,:) &
+             &             + (1.0_jprb - weight1)* g_phobic(iwn+1,:)
+        ao%lidar_ratio_mono_phobic(jwl,:) = weight1 * lidar_ratio_phobic(iwn,:) &
+             &                + (1.0_jprb - weight1)* lidar_ratio_phobic(iwn+1,:)
+        if (ao%use_hydrophilic) then
+          ao%mass_ext_mono_philic(jwl,:,:) = weight1 * mass_ext_philic(iwn,:,:) &
+               &               + (1.0_jprb - weight1)* mass_ext_philic(iwn+1,:,:)
+          ao%ssa_mono_philic(jwl,:,:)      = weight1 * ssa_philic(iwn,:,:) &
+               &               + (1.0_jprb - weight1)* ssa_philic(iwn+1,:,:)
+          ao%g_mono_philic(jwl,:,:)        = weight1 * g_philic(iwn,:,:) &
+               &               + (1.0_jprb - weight1)* g_philic(iwn+1,:,:)
+          ao%lidar_ratio_mono_philic(jwl,:,:) = weight1 * lidar_ratio_philic(iwn,:,:) &
+               &                  + (1.0_jprb - weight1)* lidar_ratio_philic(iwn+1,:,:)
+        end if
+      end do
+    end if
+
+    ! Deallocate memory local to this routine
+    deallocate(mass_ext_phobic)
+    deallocate(ssa_phobic)
+    deallocate(g_phobic)
+    deallocate(lidar_ratio_phobic)
+    if (ao%use_hydrophilic) then
+      deallocate(mass_ext_philic)
+      deallocate(ssa_philic)
+      deallocate(g_philic)
+      deallocate(lidar_ratio_philic)
+    end if
+
+    if (lhook) call dr_hook('radiation_aerosol_optics:setup_general_aerosol_optics',1,hook_handle)
+
+  end subroutine setup_general_aerosol_optics_lmdz
+    
+
+  !---------------------------------------------------------------------
+  ! Read file containing legacy-style band-wise aerosol optical
+  ! properties and average to the spectral intervals of the current
+  ! gas-optics scheme
+  subroutine setup_general_aerosol_optics_legacy(config, file_name)
+
+    use parkind1,                      only : jprb
+    use yomhook,                       only : lhook, dr_hook
+    use easy_netcdf,                   only : netcdf_file
+    use radiation_config,              only : config_type
+    use radiation_aerosol_optics_data, only : aerosol_optics_type
+    use radiation_spectral_definition, only : SolarReferenceTemperature, &
+         &                                    TerrestrialReferenceTemperature
+
+    type(config_type), intent(inout), target :: config
+
+    ! The NetCDF file containing the aerosol optics data
+    character(len=*), intent(in) :: file_name
+
+    ! Mapping matrix between optical properties at the wavenumbers in
+    ! the file, and spectral intervals used by the gas-optics scheme
+    real(jprb), allocatable :: mapping(:,:), mapping_transp(:,:)
+
+    ! Pointer to the aerosol optics coefficients for brevity of access
+    type(aerosol_optics_type), pointer :: ao
+
+    ! Local copy of aerosol optical properties in the spectral
+    ! intervals of the file, which is deallocated when it goes out of
+    ! scope
+    type(aerosol_optics_type) :: ao_legacy
+
+    integer :: jtype
+
+    real(jprb) :: hook_handle
+
+    if (lhook) call dr_hook('radiation_aerosol_optics:setup_general_aerosol_optics_legacy',0,hook_handle)
+    ao => config%aerosol_optics
+
+    ! Load file into a local structure
+    call ao_legacy%setup(file_name, iverbose=config%iverbosesetup)
+
+    ! Copy over scalars and coordinate variables
+    call ao%allocate(ao_legacy%n_type_phobic, ao_legacy%n_type_philic, ao_legacy%nrh, &
+         &           config%n_bands_lw, config%n_bands_sw, ao_legacy%n_mono_wl)
+    ao%description_phobic_str = ao_legacy%description_phobic_str
+    ao%description_philic_str = ao_legacy%description_philic_str
+    ao%rh_lower = ao_legacy%rh_lower
+
+    ! use_hydrophilic = ao_legacy%use_hydrophilic
+    ! ao%iclass = ao_legacy%iclass
+    ! ao%itype = ao_legacy%itype
+    ! ao%ntype = ao_legacy%ntype
+    ! ao%n_type_phobic = ao_legacy%n_type_phobic
+    ! ao%n_type_philic = ao_legacy%n_type_philic
+    ! ao%n_mono_wl = ao_legacy%n_mono_wl
+    ! ao%use_monochromatic = ao_legacy%use_monochromatic
+
+    if (config%do_sw) then
+      call config%gas_optics_sw%spectral_def%calc_mapping_from_wavenumber_bands(SolarReferenceTemperature, &
+           &  ao_legacy%wavenumber1_sw, ao_legacy%wavenumber2_sw, mapping_transp, &
+           &  use_bands=(.not. config%do_cloud_aerosol_per_sw_g_point))
+      if (allocated(mapping)) then
+        deallocate(mapping)
+      end if
+      allocate(mapping(config%n_bands_sw,ao_legacy%n_bands_sw))
+      mapping = transpose(mapping_transp)
+      ao%mass_ext_sw_phobic = matmul(mapping, ao_legacy%mass_ext_sw_phobic)
+      ao%ssa_sw_phobic = matmul(mapping, ao_legacy%mass_ext_sw_phobic*ao_legacy%ssa_sw_phobic) &
+           &           / ao%mass_ext_sw_phobic
+      ao%g_sw_phobic = matmul(mapping, ao_legacy%mass_ext_sw_phobic*ao_legacy%ssa_sw_phobic &
+           &                           *ao_legacy%g_sw_phobic) &
+           &         / (ao%mass_ext_sw_phobic*ao%ssa_sw_phobic)
+
+      if (ao%use_hydrophilic) then
+        do jtype = 1,ao%n_type_philic
+          ao%mass_ext_sw_philic(:,:,jtype) = matmul(mapping, ao_legacy%mass_ext_sw_philic(:,:,jtype))
+          ao%ssa_sw_philic(:,:,jtype) = matmul(mapping, ao_legacy%mass_ext_sw_philic(:,:,jtype) &
+               &                                        *ao_legacy%ssa_sw_philic(:,:,jtype)) &
+               &           / ao%mass_ext_sw_philic(:,:,jtype)
+          ao%g_sw_philic(:,:,jtype) = matmul(mapping, ao_legacy%mass_ext_sw_philic(:,:,jtype) &
+               &               *ao_legacy%ssa_sw_philic(:,:,jtype)*ao_legacy%g_sw_philic(:,:,jtype)) &
+               &         / (ao%mass_ext_sw_philic(:,:,jtype)*ao%ssa_sw_philic(:,:,jtype))
+        end do
+      end if
+    end if
+
+    if (config%do_lw) then
+      if (allocated(mapping_transp)) then
+        deallocate(mapping_transp)
+      end if
+      call config%gas_optics_lw%spectral_def%calc_mapping_from_wavenumber_bands(TerrestrialReferenceTemperature, &
+           &  ao_legacy%wavenumber1_lw, ao_legacy%wavenumber2_lw, mapping_transp, &
+           &  use_bands=(.not. config%do_cloud_aerosol_per_lw_g_point))
+      if (allocated(mapping)) then
+        deallocate(mapping)
+      end if
+      allocate(mapping(config%n_bands_lw,ao_legacy%n_bands_lw))
+      mapping = transpose(mapping_transp)
+      ao%mass_ext_lw_phobic = matmul(mapping, ao_legacy%mass_ext_lw_phobic)
+      ao%ssa_lw_phobic = matmul(mapping, ao_legacy%mass_ext_lw_phobic*ao_legacy%ssa_lw_phobic) &
+           &           / ao%mass_ext_lw_phobic
+      ao%g_lw_phobic = matmul(mapping, ao_legacy%mass_ext_lw_phobic*ao_legacy%ssa_lw_phobic &
+           &                           *ao_legacy%g_lw_phobic) &
+           &         / (ao%mass_ext_lw_phobic*ao%ssa_lw_phobic)
+
+      if (ao%use_hydrophilic) then
+        do jtype = 1,ao%n_type_philic
+          ao%mass_ext_lw_philic(:,:,jtype) = matmul(mapping, ao_legacy%mass_ext_lw_philic(:,:,jtype))
+          ao%ssa_lw_philic(:,:,jtype) = matmul(mapping, ao_legacy%mass_ext_lw_philic(:,:,jtype) &
+               &                                        *ao_legacy%ssa_lw_philic(:,:,jtype)) &
+               &           / ao%mass_ext_lw_philic(:,:,jtype)
+          ao%g_lw_philic(:,:,jtype) = matmul(mapping, ao_legacy%mass_ext_lw_philic(:,:,jtype) &
+               &               *ao_legacy%ssa_lw_philic(:,:,jtype)*ao_legacy%g_lw_philic(:,:,jtype)) &
+               &         / (ao%mass_ext_lw_philic(:,:,jtype)*ao%ssa_lw_philic(:,:,jtype))
+        end do
+      end if
+    end if
+
+    if (allocated(ao_legacy%wavelength_mono)) then
+      ao%wavelength_mono = ao_legacy%wavelength_mono
+      ao%mass_ext_mono_phobic = ao_legacy%mass_ext_mono_phobic
+      ao%ssa_mono_phobic = ao_legacy%ssa_mono_phobic
+      ao%g_mono_phobic = ao_legacy%g_mono_phobic
+      ao%lidar_ratio_mono_phobic = ao_legacy%lidar_ratio_mono_phobic
+      if (ao%use_hydrophilic) then
+        ao%mass_ext_mono_philic = ao_legacy%mass_ext_mono_philic
+        ao%ssa_mono_philic = ao_legacy%ssa_mono_philic
+        ao%g_mono_philic = ao_legacy%g_mono_philic
+        ao%lidar_ratio_mono_philic = ao_legacy%lidar_ratio_mono_philic
+      end if
+    end if
+
+    if (lhook) call dr_hook('radiation_aerosol_optics:setup_general_aerosol_optics_legacy',1,hook_handle)
+
+  end subroutine setup_general_aerosol_optics_legacy
 
 
@@ -132,5 +841,5 @@
 
     ! Loop indices for column, level, g point, band and aerosol type
-    integer :: jcol, jlev, jg, jtype
+    integer :: jcol, jlev, jg, jtype, jband
 
     ! Range of levels over which aerosols are present
@@ -139,4 +848,7 @@
     ! Indices to spectral band and relative humidity look-up table
     integer :: iband, irh
+
+    ! Short cut for ao%itype(jtype)
+    integer :: itype
 
     ! Pointer to the aerosol optics coefficients for brevity of access
